/* primax_scan -- linux driver for Primax scanners

   $Id: io.c,v 1.3 2002/09/26 16:10:23 onjo Exp $

   Authors:
   Marco Foglia <Marco.Foglia@switzerland.org>
   Thomas Schano <schano@t-online.de>
   Christian Ordig <chr.ordig@gmx.net>

   Copyright (C) 1999 Marco Foglia, Thomas Schano, Christian Ordig

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#ifndef FREEBSD /* we surely run into troubles here, when porting
				   to another platform */
#include <sys/io.h> /* iopl() */
#endif /* FREEBSD */

int set_iopl(int i)
{
#ifdef FREEBSD
  static fd_io=-1;
#endif /* FREEBSD */
  if(1 == i) { /* set I/O privileges */
#ifdef FREEBSD
	if( -1 == fd_io ) /* Check if /dev/io is already opened */
	  if( -1 == (fd_io=open("/dev/io", O_RDWR))) {
	    /* 	fprintf(stderr, "Could not open /dev/io. Are you superuser?\n"); */
	    /* 		exit(1); */
	    return -1;
	  }
#else /* Linux */
	if(iopl(3)) {
	  /* fprintf(stderr, "Could not unlock IO ports. Are you superuser?\n"); */
	  /* 	  exit(1); */
	  return -1;
	}
#endif /* FREEBSD */
  } else { /* release */
#ifdef FREEBSD
	close(fd_io);
	fd_io = -1;
#else /* Linux */
	iopl(0);
#endif /* FREEBSD */
  }
  return 0;
}
