#ifndef _LIBPRIMAX_H__
#define _LIBPRIMAX_H__

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "primax_scan.h"

#define BUFFSIZE 0x20
#ifndef CALIB_DATA_FILE
#endif

struct scan_session{ 
    int oflag;
    unsigned char* tiffdata;
    int y;
       
    int width;
    int ypixcount;
    int num_colors;
    int resolution;
    int total_width;
    int pix_read_count;
    int pix_write_count;
    int akku;
    int pointer;
    int offset_flag;
    int red_ptr;
    int green_ptr;
    int blue_ptr; 
    int read_ptr;
    int phys_line;
    char line_status[BUFFSIZE];
    char *data;
    scan_image *image;
};

int save_calibration(scan_image *image);
int load_calibration(scan_image *image);

int read_calibration_data(scan_image *image);
void read_scan_data(scan_image *image);
void wakeup(void);
int power_sequence(int sequence_code);
void wait_for_carriage(void);
int move_carrige_forward(float distance);
int move_carrige_backward(float distance);

//void scan(scan_image *image, int mode);

void prepare_scanner( scan_image *image,int mode );
int prepare_scan(struct scan_session *sc, scan_image *image);
unsigned char * get_scan_data(struct scan_session *sc, int *size);
void finish_scan(struct scan_session *sc);
void finish_scanner(void);

int lamp_on(void);
int lamp_off(void);


#endif
